declare type NS = number | string;
declare type TIMEOBJECT = {
    year: string;
    month: string;
    day: string;
    hour: string;
    minute: string;
    second: string;
};
export declare function getMonthDatesCount(year: number, month: number): number;
export declare function getDayOfDayOne(year: number, month: number): number;
export declare function getCurrentMonthDisplayDates(year: number, month: number): Array<string>;
export declare function getLastMonthDisplayDates(year: number, month: number): Array<string>;
export declare function getNextMonthDisplayDates(year: number, month: number): Array<string>;
export declare function getFormatedDate(year: NS, month: NS, date: NS): string;
export declare function getFormatedTime(year: NS, month: NS, date: NS): string;
export declare function getDateInfo(timeStamp?: NS | Date): Array<number>;
export declare function validateYear(year: NS): number;
export declare function validateMonth(month: NS): number;
export declare function validateTimeObject(timeObject: TIMEOBJECT, type?: string | undefined): TIMEOBJECT;
export declare function validateRangeResult(startTime: any, endTime: any, successCb: (() => any), failCb: (() => any)): void;
export declare function getYearRange(year: NS): {
    start: number;
    end: number;
};
export declare function insertZero(time: NS): NS;
export {};
